/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | www.openfoam.com
     \\/     M anipulation  |
-------------------------------------------------------------------------------
    Copyright (C) 2016 OpenFOAM Foundation
    Copyright (C) 2020 OpenCFD Ltd.
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "NewmarkCOM.H"
#include "addToRunTimeSelectionTable.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

namespace Foam
{
namespace RBD
{
namespace rigidBodySolvers
{
    defineTypeNameAndDebug(NewmarkCOM, 0);
    addToRunTimeSelectionTable(rigidBodySolver, NewmarkCOM, dictionary);
}
}
}


// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::RBD::rigidBodySolvers::NewmarkCOM::NewmarkCOM
(
    rigidBodyMotion& body,
    const dictionary& dict
)
:
    rigidBodySolver(body),
    gamma_(dict.getOrDefault<scalar>("gamma", 0.5)),
    beta_
    (
        max
        (
            0.25*sqr(gamma_ + 0.5),
            dict.getOrDefault<scalar>("beta", 0.25)
        )
    )
{}


// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //

Foam::RBD::rigidBodySolvers::NewmarkCOM::~NewmarkCOM()
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::RBD::rigidBodySolvers::NewmarkCOM::solve
(
    const scalarField& tau,
    const Field<spatialVector>& fx
)
{
//Info << endl << "NewmarkCOM::solve " << endl;


    // Accumulate the restraint forces
    scalarField rtau(tau);
    Field<spatialVector> rfx(fx);

    model_.applyRestraints(rtau, rfx, state());

    // Calculate the accelerations for the given state and forces
    model_.forwardDynamicsCOM(state(), rtau, rfx);

/*
Info << " ***** NMBCOM fx:  = " << fx << endl;
Info << " ***** NMBCOM rfx: = " << rfx << endl;
*/



    // Correct velocity
    qDot() = qDot0()
      + deltaT()*(gamma_*qDdot() + (1 - gamma_)*qDdot0());

    // Correct position
    q() = q0()
      + deltaT()*qDot0()
      + sqr(deltaT())*(beta_*qDdot() + (0.5 - beta_)*qDdot0());

//	vector force(0,0,0);
//	vector moment(0,  0.00628, 0);	
//	scalarField ff(spatialVector(force, moment));

//	scalarField a=q();
//	a[4] += 0.00628;
	
//	q() = a;

/*	label referenceID = model_.bodyID(reaction_);				// reaction_ means a rigid body name  
    	const vector target = target_().value(state.t());
	vector moment = Zero;
	Tensor<scalar> Rr = model_.X0(referenceID).E().T(), Rb = model_.X0(bodyID_).E().T();
	Tensor<scalar> rRb = Rr.T() & Rb;
	vector angular_vel = Rr.T() & ( model_.v(bodyID_).w() - model_.v(referenceID).w() );	
	vector posvect = (model_.X0(bodyID_).inv() && spatialVector(Zero, target_position)).l() - (model_.X0(referenceID).inv() && spatialVector(Zero, reference_position)).l();
	vector velvect = model_.v(bodyID_, target_position).l() - model_.v(referenceID, reference_position).l();
*/
/*
Info << endl;
Info << "q0 = " << q0() << ", qDot0= " << qDot0() << ", qDdot0() = " << qDdot0() << endl;
Info << "q = " << q() << ", qDot= " << qDot() << ", qDdot() = " << qDdot() << endl;
for(int i=0; i<model_.nBodies(); i++ ){
	Info << " i= " << i << " I = " << model_.I(i) << ", v_= " << model_.v(i) << ", a_ = " << model_.a(i) << endl;
	Info << "R = " <<  model_.X0(i).E() << endl;
	Info << "pos = " <<  (model_.X0(i).inv() && spatialVector(Zero, Zero)).l() << endl;
}

Info << endl;

*/


    correctQuaternionJoints();
}


// ************************************************************************* //
